// This file is auto-generated, don't edit it. Thanks.
package com.aliyun.sample;

import com.aliyun.tea.*;
import com.aliyun.ecs20140526.*;
import com.aliyun.ecs20140526.models.*;
import com.aliyun.teaopenapi.*;
import com.aliyun.teaopenapi.models.*;
import com.aliyun.teaconsole.*;
import com.aliyun.darabonba.env.*;

public class Sample {

    public static com.aliyun.ecs20140526.Client initialization(String regionId) throws Exception {
        Config config = new Config();
        // 您的AccessKey ID
        config.accessKeyId = com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_ID");
        // 您的AccessKey Secret
        config.accessKeySecret = com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_SECRET");
        // 您的可用区ID
        config.regionId = regionId;
        return new com.aliyun.ecs20140526.Client(config);
    }

    public static DescribeSecurityGroupAttributeResponse describeSecurityGroupAttribute(com.aliyun.ecs20140526.Client client, String securityGroupId, String regionId) throws Exception {
        DescribeSecurityGroupAttributeRequest req = new DescribeSecurityGroupAttributeRequest();
        req.regionId = regionId;
        req.securityGroupId = securityGroupId;
        req.direction = "all";
        DescribeSecurityGroupAttributeResponse resp = client.describeSecurityGroupAttribute(req);
        return resp;
    }

    public static void authorizeSecurityGroup(com.aliyun.ecs20140526.Client client, String securityGroupId, String regionId, String portRange, String nicType, String policy, String proiority, String sourceCidrIp) throws Exception {
        AuthorizeSecurityGroupRequest req = new AuthorizeSecurityGroupRequest();
        // 目标安全组地域ID。
        req.regionId = regionId;
        // 目标安全组ID。
        req.securityGroupId = securityGroupId;
        // 传输层协议。取值大小写敏感。取值范围：tcp udp icmp gre all：支持所有协议。
        req.ipProtocol = "udp";
        // SecurityGroupId方开放的传输层协议相关的端口范围。取值范围。
        // TCP/UDP协议：取值范围为1~65535。使用斜线（/）隔开起始端口和终止端口。正确示范：1/200；错误示范：200/1。
        // ICMP协议：-1/-1。
        // GRE协议：-1/-1。
        // IpProtocol取值为all：-1/-1。
        req.portRange = "1/200";
        // 网卡类型。取值范围：
        // internet：公网网卡。
        // intranet：内网网卡。
        req.nicType = "intranet";
        // 设置访问权限。取值范围：
        // accept（默认）：接受访问。
        // drop：拒绝访问，不返回拒绝信息。
        req.policy = "accept";
        // 安全组规则优先级。取值范围：1~100。
        req.priority = "1";
        // 源端IPv4 CIDR地址段。支持CIDR格式和IPv4格式的IP地址范围。
        // 需要设置访问权限的源端安全组ID。至少设置一项SourceGroupId或者SourceCidrIp参数。
        // 如果指定了SourceGroupId没有指定参数SourceCidrIp，则参数NicType取值只能为intranet。
        // 如果同时指定了SourceGroupId和SourceCidrIp，则默认以SourceCidrIp为准。
        req.sourceCidrIp = "10.0.0.0/8";
        try {
            client.authorizeSecurityGroup(req);
            com.aliyun.teaconsole.Client.log("--------------------入方向安全组新增成功--------------------");
        } catch (TeaException error) {
            com.aliyun.teaconsole.Client.log(error.message);
        } catch (Exception _error) {
            TeaException error = new TeaException(_error.getMessage(), _error);
            com.aliyun.teaconsole.Client.log(error.message);
        }        
    }

    public static void main(String[] args_) throws Exception {
        java.util.List<String> args = java.util.Arrays.asList(args_);
        String regionId = args.get(0);
        com.aliyun.ecs20140526.Client client = Sample.initialization(regionId);
        String groupId = args.get(1);
        String portRange = args.get(2);
        String nicType = args.get(3);
        String policy = args.get(4);
        String proiority = args.get(5);
        String sourceCidrIp = args.get(6);
        // 修改安全组入方向规则
        Sample.authorizeSecurityGroup(client, groupId, regionId, portRange, policy, nicType, proiority, sourceCidrIp);
        // 查询安全组的详情
        DescribeSecurityGroupAttributeResponse securityGroupRes = Sample.describeSecurityGroupAttribute(client, groupId, regionId);
        DescribeSecurityGroupAttributeResponseBody detail = securityGroupRes.body;
        com.aliyun.teaconsole.Client.log(" 安全组 " + detail.securityGroupName + "(" + detail.securityGroupId + ") 规则如下：");
        for (DescribeSecurityGroupAttributeResponseBody.DescribeSecurityGroupAttributeResponseBodyPermissionsPermission permission : detail.permissions.permission) {
            com.aliyun.teaconsole.Client.log("   规则描述： " + permission.description + ";");
            com.aliyun.teaconsole.Client.log("   方向： " + permission.direction + ";");
            com.aliyun.teaconsole.Client.log("   端口范围： " + permission.sourcePortRange + ";");
            com.aliyun.teaconsole.Client.log("   源端IPv4 CIDR地址段： " + permission.sourceCidrIp + ";");
            com.aliyun.teaconsole.Client.log("   网卡类型： " + permission.nicType + ";");
            com.aliyun.teaconsole.Client.log("   访问权限： " + permission.policy + ";");
            com.aliyun.teaconsole.Client.log("   规则优先级： " + permission.priority + ";");
            com.aliyun.teaconsole.Client.log("   创建时间： " + permission.createTime + ";");
        }
    }
}
